#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
TP Python Images 
BCPST
"""

###################################
#   imports de bibliothèques      #
###################################

#activer la ligne suivant si on utilise Python2
#from __future__ import division
from PIL import Image
import matplotlib.pyplot as plt
import numpy as np

#################
#    exo1       #
#################

#from PIL import Image

"""
source = Image.open('lena.png')
pixelsource = source.getdata()
but = source.convert('L')
pixelbut = but.getdata()
but.save('lenagray.png')
but.show()
"""

def exo1_question2():
    #ouvrir l'image
    source = Image.open('lena.png')
    #récupérer les pixels dans une structure de type liste
    pixelsource = source.getdata()
    #convertir l'image source en niveaux de gris
    but = source.convert('L')
    #récupérer les pixels de l'image modifiée
    pixelbut = but.getdata()
    but.save('lenagray.png')
    but.show()

def ouvrir(fichier):
    """ouvre un fichier image et affiche l'image et quelques 
    informations"""
    img = Image.open(fichier)
    print('Format :',img.format)
    print('Mode : ',img.mode)
    print('Dimensions :',img.size)
    pixels = img.load()
    print('Pixel (0;0) :',pixels[0,0])
    img.show()

def nuanciergris():
    img = Image.new('L',(256,256))
    #pixels = img.load()
    for y in range(256):
        for x in range(256):
            img.putpixel((x,y),x)
            #pixels[x,y] = x
    img.save('nuanciergris.png')
    img.show()

def exo1():
    ouvrir('lena.png')
    nuanciergris()


#################
#    exo2       #
#################

"""
img = Image.open('lenagray.png')
matrice = np.array(img)
print(matrice.shape)
print(matrice[0][0])
"""
def exo2():  
    #import matplotlib.pyplot as plt
    matrice2 = plt.imread('lenagray.png')
    plt.subplot(121) #première sous figure
    plt.imshow(matrice2,cmap='graymatr') #ajout de l'image à la figure avec la palette niveaux de gris
    plt.colorbar() #ajout d'une barre des couleurs de la palette
    plt.subplot(122) #seconde sous figure
    plt.hist(matrice2.flatten(), bins=256,range=(0,1),facecolor='green') #histogramme
    plt.subplots_adjust(wspace=0.3) #ajustement de l'espace horizontal entre les subplots
    plt.savefig('lena+histo.png') #enregistrement sur disque
    plt.show()  #affichage à l'écran

#################
#    exo3       #
#################



def bruitage(matrice):
    H,W = matrice.shape
    matrice2 = matrice.copy()
    for y in range(H):
        #array des 50 pixels bruités sur la ligne
        bruit = np.random.randint(0,W-1,50)
        for x in bruit:
            matrice2[y][x] = 0
    return matrice2


def exo3_test_bruitage():
    m= np.zeros((512,512))
    r = np.random.randint(0,512,5)
    matricesource = plt.imread('lenagray.png')
    matricebruit = bruitage(matricesource)
    plt.imsave('bruit.png',matricebruit,cmap='gray')

def distance(matrice1,matrice2):
    H,W = matrice1.shape
    if matrice1.shape != matrice2.shape:
        return "Les images ne sont pas de même dimension"
    else:
        matrice3 = np.zeros((H,W))
        for y in range(H):
            for x in range(W):
                matrice3[y][x] = abs(matrice1[y][x]-matrice2[y][x])
    return matrice3

def ajout(matrice1,matrice2):
    H,W = matrice1.shape
    if matrice1.shape != matrice2.shape:
        return "Les images ne sont pas de même dimension"
    else:
        matrice3 = np.zeros((H,W))+1
        for y in range(H):
            for x in range(W):
                somme = matrice1[y][x]+matrice2[y][x]
                if somme>1:
                    matrice3[y][x] = 1
                else:
                    matrice3[y][x] = somme
    return matrice3

def exo3():
    matrice1 = plt.imread('lenagray.png')
    matrice2 = bruitage(matrice1)
    matrice3 = distance(matrice1,matrice2)
    plt.subplot(131)
    plt.title('image source')
    plt.imshow(matrice1,cmap='gray')
    plt.subplot(132)
    plt.title('image bruitée')
    plt.imshow(matrice2,cmap='gray')
    plt.subplot(133)
    plt.title('distance')
    plt.imshow(matrice3,cmap='gray')
    plt.subplots_adjust(wspace=0.3) 
    plt.savefig('frise+distance.png')
    plt.show()


#################
#    exo4       #
#################

def filtre_inversion(image1):
    """Procédure qui prend en argument une image en niveaux de gris
    et retourne l'image inversée """
    L,H = image1.size
    image2 = Image.new('L',(L,H))
    pixels = image1.load()
    pixels2 = image2.load()
    #boucle sur les lignes
    for y in range(H):
        #boucle sur les colonnes
        for x in range(L):
            pixels2[x,y] = 255-pixels[x,y]
    return image2

def exo4():
    source = Image.open('lenagray.png')
    but = filtre_inversion(source)
    but.save('lenainverse.png')
    but.show()

#################
# exos 5 et 6   #
#################


def filtre(matrice,fonction):
    """retourne une nouvelle matrice2 image de la matrice d'entrée
    par la fonction appliquée élément par élément"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    matrice2 = np.zeros((nlines,ncols))
    for i in range(nlines):
        for j in range(ncols):
            matrice2[i][j] = fonction(matrice[i][j])
    return matrice2

def carre(x):
    """x**2"""
    #une fonction filtre pour assombrir
    return x**2

def racine(x):
    """sqrt(x)"""
    #une fonction filtre pour éclaircir
    return  np.sqrt(x)

def inverse(x):
    """1-x"""
    #une fonction filtre pour inverser
    return 1-x

def  seuil(x,s=0.5):
    """seuil"""
    #un filtre de seuil
    if x>s:
        return 1
    else:
        return x
                                           
def contraste1(x):
    """3*x**2-2*x**3"""
    #un filtre de contraste
    return 3*x**2-2*x**3

def contraste2(x):
    """x**3*(6*x**2-15*x+10)"""
    #un autre filtre de contraste
    return x**3*(6*x**2-15*x+10)
    

def tracerfiltres(*args):
    """représente graphiquement sur [0;1]
    les courbes des fonctions de filtres passées
    en argument"""
    x = np.linspace(0,1,501)
    for fonction in args:
        #choix d'une couleur au hasard codée en (R,G,B)
        r,g,b = tuple(np.random.random_sample(size=3))
        plt.plot(x,fonction(x),color=(r,g,b),label=fonction.__doc__,lw=2)
    plt.legend(loc='upper center',fontsize=10)
    plt.title('Fonctions de filtre')
    plt.savefig('filtres.png')
    plt.show()

def exo56():
    source = plt.imread('lenagray.png')
    #graphiques avec toutes les images obtenues par application des filtres
    #codage de la figure (2 lignes, 3 colonnes pour 6 images)
    n = 231    
    for fonction in [carre,racine,inverse,seuil,contraste1,contraste2]:
        but = filtre(source,fonction)
        plt.subplot(n)
        plt.imshow(but,cmap='gray')
        n += 1
    plt.suptitle('Exos 6 et 7 : Mosaique des filtres')
    plt.savefig('mosaique_filtres_lena.png')
    plt.show()    
    #tracé desfonctions de filtres
    tracerfiltres(carre,racine,inverse,contraste1,contraste2)

#################
#    exo7       #
#################

def zoom(matrice,fact=1):
    """Prend en entrée une matrice d'image et retourne une nouvelle matrice
    d'image correspondant à un zoom de l'image initiale"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    nlineszoom,ncolszoom = int(nlines*fact),int(ncols*fact)
    matrice2 = np.zeros((nlineszoom,ncolszoom))
    for x in range(ncols):
        for y in range(nlines):
            matrice2[y][x] = matrice[y//fact][x//fact]
    return matrice2

def quart_tour_direct(matrice):
    """prend en entrée une matrice image et retourne la matrice
    de l'image obtenue par un quart de tour direct de centre le coin supérieur 
    gauche de l'image source"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    matrice2 = np.zeros((ncols,nlines))
    for x in range(ncols):
        for y in range(nlines):
            matrice2[y][x] = matrice[x][ncols-1-y]
    return matrice2

def quart_tour_indirect(matrice):
    """prend en entrée une matrice image et retourne la matrice
    de l'image obtenue par un quart de tour indirect de centre le coin supérieur 
    gauche de l'image source"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    matrice2 = np.zeros((ncols,nlines))
    for x in range(ncols):
        for y in range(nlines):
            matrice2[y][x] = matrice[nlines-1-x][y]
    return matrice2

def demi_tour(matrice):
    """prend en entrée une matrice image et retourne la matrice
    de l'image obtenue par un demi tour de centre le coin supérieur 
    gauche de l'image source"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    matrice2 = np.zeros((ncols,nlines))
    for x in range(ncols):
        for y in range(nlines):
            matrice2[y][x] = matrice[nlines-1-y][ncols-1-x]
    return matrice2


def flip(matrice):
    """prend en entrée une matrice image et retourne la matrice
    de l'image obtenue par une réflexion par rapport à l'axe horizontal supérieur 
    """
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéro
    matrice2 = np.zeros((ncols,nlines))
    for x in range(ncols):
        for y in range(nlines):
            matrice2[y][x] = matrice[nlines-1-y][x]
    return matrice2
   
      
def flop(matrice):
    """prend en entrée une matrice image et retourne la matrice
    de l'image obtenue par une réflexion par rapport à l'axe vertical droit 
    """
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéro
    matrice2 = np.zeros((ncols,nlines))
    for x in range(ncols):
        for y in range(nlines):
            matrice2[y][x]= matrice[y][ncols-1-x]
    return matrice2


def exo7():
    #img = Image.open('lenagray.png')
    #matrice = np.array(img)
    matrice = plt.imread('lenagray.png')
    plt.subplot(221)
    plt.imshow(matrice,cmap='gray')
    plt.title('Original')
    plt.subplot(222)
    plt.imshow(flop(matrice),cmap='gray')
    plt.title('Flop')
    plt.subplot(223)
    plt.imshow(flip(matrice),cmap='gray')
    plt.title('Flip')
    plt.subplot(224)
    plt.imshow(quart_tour_direct(matrice),cmap='gray')
    plt.title('Quart de tour direct')
    plt.subplots_adjust(wspace=0.3,hspace=0.3)
    plt.savefig('frise-transformations.png')
    plt.show()

def exo7_zoom(fact,fichier='lenagray.png'):
    matrice_source = plt.imread(fichier)
    matrice_zoom = zoom(matrice_source,fact)
    plt.imsave('lenagrayzoom.png',matrice_zoom,cmap='gray')
    
    
#################
#    exo8       #
#################

def filtre_contour(matrice,seuil=0.05):
    """prend en entrée uen matrice image et retourne
    une matrice image obtenue par un filtre d'extraction de contour"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    matrice2 = np.zeros((nlines,ncols))
    for y in range(nlines-1):
        for x in range(ncols-1):
            #si le pixel (x,y) est différent de celui à sa droite (x+1,y)
            #ou de celui en-dessous (x,y+1) on le conserve
            pixel = matrice[y][x]
            if abs(pixel-matrice[y+1][x])>seuil or abs(pixel-matrice[y][x+1])>seuil:
                matrice2[y][x] = pixel
            else:
                matrice2[y][x] = 1 #sinon on le colorie en blanc
    return matrice2

def  seuil(x,s=0.5):
    """seuil"""
    #un filtre de seuil
    if x>s:
        return 1
    else:
        return x

def filtre(matrice,fonction):
    """retourne une nouvelle matrice2 image de la matrice d'entrée
    par la fonction appliquée élément par élément"""
    nlines,ncols = matrice.shape
    #on crée une nouvelle matrice de meme dimension remplie de zéros
    matrice2 = np.zeros((nlines,ncols))
    for i in range(nlines):
        for j in range(ncols):
            matrice2[i][j] = fonction(matrice[i][j])
    return matrice2

def exo8():    
    #img = Image.open('lenagray.png')
    #matrice = np.array(img)
    matrice = plt.imread('lenagray.png')
    plt.subplot(121)
    plt.imshow(filtre(matrice,seuil),cmap='gray')
    plt.title('Seuillage au seuil 0,4 (ou 102/255)')
    plt.subplot(122)
    plt.imshow(filtre_contour(matrice),cmap='gray')
    plt.title('Contour au seuil 0,08 (ou 20/255)')
    plt.subplots_adjust(wspace=0.3) 
    plt.savefig('frise-seuil-contour.png')
    plt.show()

#################
#    exo9       #
#################


def filtre_convolution(matrice,noyau,biais=0,iterations=1):
    """Prend en entrée une matrice d'image et retourne une autre matrice
    d'image de meme dimension obtenue par application itérées d'un filtre de convolution
    """
    nlines,ncols = matrice.shape
    #copie superficielle de la matrice source 
    matrice1 = matrice[:]
    for i in range(iterations):
        #on crée une nouvelle matrice de meme dimension remplie de zéros
        matrice2 = np.zeros((nlines,ncols))
        #on parcourt toutes les lignes et toutes les colonnes de la matrice initiale
        #sauf les premières et dernières
        for y in range(1,nlines-1):
            for x in range(1,ncols-1):
                #somme des coefficients du noyau
                diviseur = sum([sum(noyau[i]) for i in range(3)])
                #parcourt la matrice noyau pour calculer la nouvelle valeur du pixel en (x,y)
                newpixel = 0
                for i in range(3):
                    for j in range(3):
                        newpixel += noyau[i][j]*matrice1[y-1+i][x-1+j]
                #on normalise en divisant par le diviseur
                newpixel /= diviseur
                newpixel += biais
                matrice2[y][x] = newpixel
        matrice1 = matrice2
    return matrice2


def exo9():
    noyau = [[0,1,0],[1,1,1],[0,1,0]]    #affiche(filtre_convolution(mat2f,noyau=[[0,1,0],[1,1,1],[0,1,0]],iterations=3),histo=True,nom='bateaubruite+filtre-flou')
    matrice = plt.imread('bateaubruite.png')
    plt.subplot(131)
    plt.imshow(matrice,cmap='gray')
    plt.title('Image bruite')
    plt.subplot(132)
    plt.imshow(filtre_convolution(matrice,noyau,biais=0,iterations=1),cmap='gray')
    plt.title('Filtre B, 1 itération')
    plt.subplot(133)
    plt.imshow(filtre_convolution(matrice,noyau,biais=0,iterations=4),cmap='gray')
    plt.title('Filtre B, 4 itérations')
    plt.subplots_adjust(wspace=0.3) 
    plt.savefig('frise-convolution-floutage.png')
    plt.show()

